"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const MasonryFlatlist = /*#__PURE__*/(0, _react.forwardRef)((_ref, ref) => {
  let {
    columnWrapperStyle,
    data,
    ListHeaderComponent,
    ListEmptyComponent,
    ListFooterComponent,
    ListHeaderComponentStyle,
    containerStyle,
    contentContainerStyle,
    renderItem,
    onEndReachedThreshold,
    onEndReached,
    loading,
    LoadingView,
    numColumns = 2,
    horizontal,
    onScroll,
    removeClippedSubviews = false,
    keyExtractor,
    style,
    ...rest
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(_reactNative.ScrollView, _extends({}, rest, {
    ref: ref,
    style: [styles.scrollView, containerStyle],
    contentContainerStyle: contentContainerStyle,
    removeClippedSubviews: removeClippedSubviews,
    scrollEventThrottle: 16,
    onScroll: e => {
      const nativeEvent = e.nativeEvent;

      if (isCloseToBottom(nativeEvent, onEndReachedThreshold || 0.0)) {
        onEndReached === null || onEndReached === void 0 ? void 0 : onEndReached();
      }

      onScroll === null || onScroll === void 0 ? void 0 : onScroll(e);
    }
  }), /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: ListHeaderComponentStyle
  }, ListHeaderComponent), data.length === 0 && ListEmptyComponent ? /*#__PURE__*/_react.default.isValidElement(ListEmptyComponent) ? ListEmptyComponent : /*#__PURE__*/_react.default.createElement(ListEmptyComponent, null) : /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [{
      flex: 1,
      flexDirection: horizontal ? 'column' : 'row'
    }, style]
  }, Array.from(Array(numColumns), (_, num) => {
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      key: `masonry-flatlistcolumn-${num}`,
      style: {
        flex: 1 / numColumns,
        flexDirection: horizontal ? 'row' : 'column'
      }
    }, data.map((el, i) => {
      if (i % numColumns === num) {
        return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
          key: (keyExtractor === null || keyExtractor === void 0 ? void 0 : keyExtractor(el, i)) || `masonry-flatlistrow-${num}-${i}`,
          style: columnWrapperStyle
        }, renderItem({
          item: el,
          index: i
        }));
      }

      return null;
    }).filter(e => !!e));
  })), loading && LoadingView, ListFooterComponent));
});

const isCloseToBottom = (_ref2, onEndReachedThreshold) => {
  let {
    layoutMeasurement,
    contentOffset,
    contentSize
  } = _ref2;
  const paddingToBottom = contentSize.height * onEndReachedThreshold;
  return layoutMeasurement.height + contentOffset.y >= contentSize.height - paddingToBottom;
};

var _default = /*#__PURE__*/(0, _react.memo)(MasonryFlatlist);

exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  scrollView: {
    flex: 1,
    alignSelf: 'stretch'
  }
});
//# sourceMappingURL=index.js.map