function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { memo, forwardRef } from 'react';
import { ScrollView, View, StyleSheet } from 'react-native';
const MasonryFlatlist = /*#__PURE__*/forwardRef((_ref, ref) => {
  let {
    columnWrapperStyle,
    data,
    ListHeaderComponent,
    ListEmptyComponent,
    ListFooterComponent,
    ListHeaderComponentStyle,
    containerStyle,
    contentContainerStyle,
    renderItem,
    onEndReachedThreshold,
    onEndReached,
    loading,
    LoadingView,
    numColumns = 2,
    horizontal,
    onScroll,
    removeClippedSubviews = false,
    keyExtractor,
    style,
    ...rest
  } = _ref;
  return /*#__PURE__*/React.createElement(ScrollView, _extends({}, rest, {
    ref: ref,
    style: [styles.scrollView, containerStyle],
    contentContainerStyle: contentContainerStyle,
    removeClippedSubviews: removeClippedSubviews,
    scrollEventThrottle: 16,
    onScroll: e => {
      const nativeEvent = e.nativeEvent;

      if (isCloseToBottom(nativeEvent, onEndReachedThreshold || 0.0)) {
        onEndReached === null || onEndReached === void 0 ? void 0 : onEndReached();
      }

      onScroll === null || onScroll === void 0 ? void 0 : onScroll(e);
    }
  }), /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(View, {
    style: ListHeaderComponentStyle
  }, ListHeaderComponent), data.length === 0 && ListEmptyComponent ? /*#__PURE__*/React.isValidElement(ListEmptyComponent) ? ListEmptyComponent : /*#__PURE__*/React.createElement(ListEmptyComponent, null) : /*#__PURE__*/React.createElement(View, {
    style: [{
      flex: 1,
      flexDirection: horizontal ? 'column' : 'row'
    }, style]
  }, Array.from(Array(numColumns), (_, num) => {
    return /*#__PURE__*/React.createElement(View, {
      key: `masonry-flatlistcolumn-${num}`,
      style: {
        flex: 1 / numColumns,
        flexDirection: horizontal ? 'row' : 'column'
      }
    }, data.map((el, i) => {
      if (i % numColumns === num) {
        return /*#__PURE__*/React.createElement(View, {
          key: (keyExtractor === null || keyExtractor === void 0 ? void 0 : keyExtractor(el, i)) || `masonry-flatlistrow-${num}-${i}`,
          style: columnWrapperStyle
        }, renderItem({
          item: el,
          index: i
        }));
      }

      return null;
    }).filter(e => !!e));
  })), loading && LoadingView, ListFooterComponent));
});

const isCloseToBottom = (_ref2, onEndReachedThreshold) => {
  let {
    layoutMeasurement,
    contentOffset,
    contentSize
  } = _ref2;
  const paddingToBottom = contentSize.height * onEndReachedThreshold;
  return layoutMeasurement.height + contentOffset.y >= contentSize.height - paddingToBottom;
};

export default /*#__PURE__*/memo(MasonryFlatlist);
const styles = StyleSheet.create({
  scrollView: {
    flex: 1,
    alignSelf: 'stretch'
  }
});
//# sourceMappingURL=index.js.map